/**
 
  \brief HankelFunction
  \authors Nikolai Amelin (amelin@sunhe.jinr.ru), Ludmila Malinina (malinina@sunhe.jinr.ru), Timur Pocheptsov (pocheptsov@sunhe.jinr.ru) 
  \date 2 Nov 2005
  \copyright JINR/Dubna
*/

#ifndef HANKELFUNCTION_INCLUDED
#define HANKELFUNCTION_INCLUDED

#include <Rtypes.h>

Double_t HankelK0(Double_t x);
Double_t HankelK1(Double_t x);
/// compute modified Hankel function of the second,...,order
Double_t HankelKn(Int_t n, Double_t x);

#endif
