/**
 
  \brief HadronDecayer 
  \authors Nikolai Amelin (amelin@sunhe.jinr.ru), Ludmila Malinina (malinina@sunhe.jinr.ru), Timur Pocheptsov (pocheptsov@sunhe.jinr.ru) 
  \date 2 Nov 2005
  \copyright JINR/Dubna
*/

#ifndef HADRONDECAYER_INCLUDED
#define HADRONDECAYER_INCLUDED

//#include "Rtypes.h"
#include "DatabasePDG.h"
#include "Particle.h"

Double_t GetDecayTime(const Particle &p, Double_t weakDecayLimit);
void Decay(List_t &output, Particle &p, ParticleAllocator &hj_allocator, DatabasePDG *database);

#endif
